Attribute VB_Name = "ModBrowse"
Option Explicit
'--this module is just for fileopen and filesave browse windows.

Private Const OFN_ALLOWMULTISELECT = &H200
Private Const OFN_EXPLORER = &H80000
Private Const OFN_MULTI_SEL = OFN_ALLOWMULTISELECT Or OFN_EXPLORER
Private Const OFN_EXTENSIONDIFFERENT = &H400
Private Const OFN_PATHMUSTEXIST = &H800
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_NOREADONLYRETURN = &H8000
Private Const OFN_READONLY = &H1

Private Const FILTER_ALL1 As String = "All Files(*.*)"
Private Const FILTER_ALL2 As String = "*.*"

Public Const MAX_SZ As Long = 255

Private Type OPENFILENAME
        lStructSize As Long
        hWndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Private Declare Function GetSaveFileName Lib "COMDLG32.DLL" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetOpenFileName Lib "COMDLG32.DLL" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long


Public Function DOpenMulti(hForm As Long, BoxTitle As String, Optional sFolPath As String) As String
  Dim boo As Boolean
   Dim OFN As OPENFILENAME
   Dim Sp As Long, LOffset As Long, LBuf As Long, NullPt As Long
   Dim sFil As String, sFilter As String, NullChr As String, Null2 As String
    NullChr = Chr(0)
    Null2 = NullChr & NullChr
    sFilter = FILTER_ALL1 & NullChr & FILTER_ALL2 & Null2
    LBuf = MAX_SZ * 4
   With OFN
    .hWndOwner = hForm
    .hInstance = App.hInstance
    .lpstrTitle = BoxTitle
    .lpstrFilter = sFilter
    .nFilterIndex = 1
    .lpstrFile = String$(LBuf, 0)
    .nMaxFile = LBuf - 1
    .flags = OFN_MULTI_SEL Or OFN_HIDEREADONLY
   End With
   
   On Error GoTo woops
   If Not IsMissing(sFolPath) Then
     If DoesFolderExist(sFolPath) = True Then
       OFN.lpstrInitialDir = sFolPath
     End If
   End If
     OFN.lStructSize = Len(OFN)
     
      boo = GetOpenFileName(OFN)
    If boo = True Then
       sFil = Left$(OFN.lpstrFile, OFN.nMaxFile - 1)
         NullPt = InStr(1, sFil, Null2, vbBinaryCompare)
         If NullPt <> 0 Then sFil = Left$(sFil, (NullPt - 1))
    Else
      sFil = ""
    End If
   DOpenMulti = sFil
  Exit Function
woops:
  DOpenMulti = ""
   
End Function

Public Function SaveFile(hForm As Long, BoxTitle As String, sDefName) As String
  Dim boo As Boolean
 Dim OFN As OPENFILENAME
 Dim Sp As Long
 Dim sFil As String, sFilter As String, sDefExt As String, sDefFil As String
 Dim NullChr As String
   NullChr = Chr(0)
  sFilter = "Zip files(*.zip)" & NullChr & "*.zip" & NullChr & NullChr
  sDefExt = "zip"
 
   With OFN
    .flags = OFN_HIDEREADONLY
    .hWndOwner = hForm
    .hInstance = App.hInstance
    .lpstrTitle = BoxTitle
    .lpstrFilter = sFilter
    .nFilterIndex = 0
    .lpstrDefExt = sDefExt
    .lpstrFile = String$(MAX_SZ, 0)
    .nMaxFile = MAX_SZ - 1
   End With
   
     If (sDefName <> "") Then
       sDefFil = sDefName & String$((MAX_SZ - Len(sDefName)), 0)
       OFN.lpstrFile = sDefFil
     End If
      OFN.lStructSize = Len(OFN)
      
   On Error GoTo woops
    boo = GetSaveFileName(OFN)
     If (boo = True) Then
       sFil = Left$(OFN.lpstrFile, OFN.nMaxFile)
        Sp = InStr(1, sFil, NullChr, vbBinaryCompare)
         If Sp <> 0 Then
            sFil = Left$(sFil, Sp - 1)
         End If
     Else
       sFil = ""
     End If
     
       SaveFile = sFil
   Exit Function
woops:
   SaveFile = ""
End Function

Public Function DoesFolderExist(ByVal sPath As String) As Boolean
  On Error Resume Next
    DoesFolderExist = (GetAttr(sPath) And vbDirectory) = vbDirectory
    Err.Clear
End Function




